var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { Pagination, PaginationItem } from 'cf-component-pagination';
import { Icon } from 'cf-component-icon';

var PaginationBuilder = function (_React$Component) {
  _inherits(PaginationBuilder, _React$Component);

  function PaginationBuilder() {
    _classCallCheck(this, PaginationBuilder);

    return _possibleConstructorReturn(this, (PaginationBuilder.__proto__ || Object.getPrototypeOf(PaginationBuilder)).apply(this, arguments));
  }

  _createClass(PaginationBuilder, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          totalItems = _props.totalCount,
          page = _props.page,
          perPage = _props.perPage,
          infoFormatter = _props.infoFormatter,
          loading = _props.loading,
          onPageChange = _props.onPageChange;


      var totalPages = Math.ceil(totalItems / perPage);
      var pageIndex = this.props.page - 1;
      var start = Math.max(pageIndex * perPage + 1, 1);
      var end = Math.min(start + perPage - 1, totalItems);

      var handleClickItem = function handleClickItem(page) {
        if (page >= 1 && page <= totalPages) {
          onPageChange(page);
        }
      };

      var items = [];

      var prevWasEllipsis = false;

      var _loop = function _loop(i) {
        if (
        // First Page:
        i === 1 ||
        // Last Page:
        i === totalPages ||
        // Current Page:
        i === page ||
        // Within 2 of page:
        Math.abs(page - i) <= 2 ||
        // Within 3 of page and next to start or end: (Why? Because if we show an ellipsis instead of just a single number then wtf was the point)
        Math.abs(page - i) <= 3 && (i === 2 || i === totalPages - 1)) {
          prevWasEllipsis = false;
          items.push(React.createElement(
            PaginationItem,
            {
              key: i,
              type: loading && page === i ? 'loading' : 'number',
              label: 'Page ' + i,
              active: page === i,
              onClick: function onClick() {
                return handleClickItem(i);
              }
            },
            i
          ));
        } else if (!prevWasEllipsis) {
          prevWasEllipsis = true;
          items.push(React.createElement(PaginationItem, {
            key: i,
            type: 'ellipsis',
            label: 'Page ' + i,
            onClick: function onClick() {
              return null;
            }
          }));
        }
      };

      for (var i = 1; i <= totalPages; i++) {
        _loop(i);
      }

      var info = infoFormatter && infoFormatter(start, end, totalItems);

      return React.createElement(
        Pagination,
        { info: info },
        React.createElement(
          PaginationItem,
          {
            type: 'prev',
            label: 'Previous Page',
            disabled: page === 1,
            onClick: function onClick() {
              return handleClickItem(page - 1);
            }
          },
          React.createElement(Icon, {
            color: page === 1 ? 'default' : 'white',
            type: 'caret-left',
            label: false
          })
        ),
        items,
        React.createElement(
          PaginationItem,
          {
            type: 'next',
            label: 'Next Page',
            disabled: page === totalPages,
            onClick: function onClick() {
              return handleClickItem(page + 1);
            }
          },
          React.createElement(Icon, {
            type: 'caret-right',
            color: page === totalPages ? 'default' : 'white',
            label: false
          })
        )
      );
    }
  }]);

  return PaginationBuilder;
}(React.Component);

PaginationBuilder.propTypes = {
  onPageChange: PropTypes.func.isRequired,
  loading: PropTypes.bool,

  totalCount: PropTypes.number.isRequired,
  page: PropTypes.number.isRequired,
  perPage: PropTypes.number.isRequired,

  infoFormatter: PropTypes.func
};

export default PaginationBuilder;